// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001 Universitaet Karlsruhe, Germany
//                    and Chalmers University of Technology, Sweden          
//
// The KeY system is protected by the GNU General 
// Public License. See LICENSE.TXT for details.
//

package de.uka.ilkd.key.proof;

import de.uka.ilkd.key.logic.*;
import java.util.HashMap;
import java.util.ArrayList;

import de.uka.ilkd.key.logic.op.*;

/* No comment available*/

public class TermSVReplacer {

    HashMap schemaVariables;
    Term from, to;

    TermFactory fact;

    public TermSVReplacer(HashMap map) {
	fact = TermFactory.DEFAULT;
	schemaVariables = map;
    }
    
    public Term inst(Term t) {
	Term result = null;
	if (t.op() instanceof ProgramVariable){ 
	    result = t;
	    if (schemaVariables.containsKey(t.op())) {
		result = TermFactory.DEFAULT.createVariableTerm
		    ((SchemaVariable) schemaVariables.get(t.op()));
	    }
	} else {
	    Term subTerms[] = new Term[t.arity()];
	    ArrayList vars = new ArrayList();
	    for ( int i = 0; i<t.arity(); i++ ) {
		ArrayOfQuantifiableVariable vbh = t.varsBoundHere(i);
		for( int j=0; j<vbh.size(); j++ ) {
		    vars.add((SchemaVariable)(vbh.getQuantifiableVariable(j)));
		}
		subTerms[i] = inst(t.sub(i));
	    }
	    QuantifiableVariable v1[] = new QuantifiableVariable[0];
	    v1 = (QuantifiableVariable[])(vars.toArray(v1));
	    result = fact.createTerm(t.op(),subTerms,v1,null,null);
	   
	}
	return result;


    }


}

